BOZOHTTPD(8) | System Manager's Manual | BOZOHTTPD(8)

# NAME

bozohttpd — hyper text transfer protocol version 1.1 daemon

# SYNOPSIS

bozohttpd | [-EGHVXefhnsu] [-C suffix cgihandler] [-I port] [-L prefix script] [-M suffix type encoding encoding11] [-P pidfile] [-S server_software] [-U username] [-Z cert privkey] [-c cgibin] [-i address] [-p pubdir] [-t chrootdir] [-v virtualroot] [-x index] [-z ciphers] slashdir [myname]

# DESCRIPTION

The bozohttpd program reads a HTTP request from the standard input, and sends a reply to the standard output. Besides ~user translation and virtual hosting support (see below), all file requests are from slashdir directory. The server uses myname as its name, which defaults to the local hostname, obtained from gethostname(3) (but see the -v option for virtual hosting.) bozohttpd writes logs to syslog(3) using the ftp facility (but see the -s option for testing.) bozohttpd is designed to be small, simple and relatively featureless, hopefully increasing its security.

## OPTIONS

The following options are available:

-b
  Enables daemon mode, where bozohttpd detaches from the current terminal, running in the background and servicing HTTP requests.
-C suffix cgihandler
  Adds a new CGI handler program for a particular file type. The suffix should be any normal file suffix, and the cgihandler should be a full path to an interpreter. This option is the only way to enable CGI programs that exist outside of the cgibin directory to be executed. Multiple -C options may be passed.
-c cgibin
  Enables the CGI/1.1 interface. The cgibin directory is expected to contain the CGI programs to be used. bozohttpd looks for URL's in the form of /cgi-bin/<scriptname> where ⟨scriptname⟩ is a valid CGI program in the cgibin directory. In other words, all CGI URL's must begin with /cgi-bin/. Note that the CGI/1.1 interface is available with ~user translation using -E switch.
-e
  Causes bozohttpd to not clear the environment when used with either the -t or -U options.
-f
  Stops the -b flag from bozohttpd detaching from the tty and going into the background.
-G
  Get the bozohttpd version string, print it on standard output, and exit.
-H
  Causes directory index mode to hide files and directories that start with a period, except for ... Also see -X.
-I port
  Causes bozohttpd to use port instead of the default “http” port. When used with the -b option, it changes the bound port. Otherwise it forces redirections to use this port instead of the value obtained via getsockname(2).
-i address
  Causes address to be used as the address to bind daemon mode. If otherwise unspecified, the address used to bind is derived from the myname, which defaults to the name returned by gethostname(3). Only the last -i option is used. This option is only valid with the -b option.
-L prefix script
  Adds a new Lua script for a particular prefix. The prefix should be an arbitrary text, and the script should be a full path to a Lua script. Multiple -L options may be passed. A separate Lua state is created for each prefix. The Lua script can register callbacks using the httpd.register_handler('<name>', function) Lua function, which will trigger the execution of the Lua function function when a URL in the form http://<hostname>/<prefix>/<name> is being accessed. The function is passed three tables as arguments, the server environment, the request headers, and the decoded query string plus any data that was sent as application/x-www-form-urlencoded.
-M suffix type encoding encoding11
  Adds a new entry to the table that converts file suffixes to content type and encoding. This option takes four additional arguments containing the file prefix, its “Content-Type”, “Content-Encoding”, and “Content-Encoding” for HTTP/1.1 connections, respectively. If any of these are a single dash (“-”), the empty string is used instead. Multiple -M options may be passed.
-n
  Stops bozohttpd from doing IP address to name resolution of hosts for setting the `REMOTE_HOST` variable before running a CGI program. This option has no effect without the -c option.
-P pidfile
  Causes bozohttpd to create a pid file in pidfile when run in daemon mode with the -b option.
-p pubdir
  Changes the default user directory for /~user/ translations from “public_html” to pubdir.
-S server_software
  Sets the internal server version to server_software.
-s
  Forces logging to be set to stderr always.
-t chrootdir
  Makes bozohttpd chroot to the specified directory before answering requests. Every other path should be specified relative to the new root, if this option is used. Note that the current environment is normally replaced with an empty environment with this option, unless the -e option is also used.
-U username
  Causes bozohttpd to switch to the user and the groups of username after initialization. This option, like -t above, causes bozohttpd to clear the environment unless the -e option is given.
-u
  Enables the transformation of Uniform Resource Locators of the form /~user/ into the directory ~user/public_html (but see the -p option above).
-E
  Enables CGI/1.1 interface for ~user translation. Note that enabling this support implies that users can run commands as web server user, this may have security implications.
-V
  Sets the backup virtual host directory to the slashdir argument. If no directory exists in virtualroot for the request, then slashdir will be used. The default behaviour is to return 404 (Not Found.)
-v virtualroot
  Enables virtual hosting support. Directories in virtualroot will be searched for a matching virtual host name, when parsing the HTML request. If a matching name is found, it will be used as both the server's real name, [myname], and as the slashdir. See the EXAMPLES section for an example of using this option.
-X
  Enables directory indexing. A directory index will be generated only when the default file (i.e. index.html normally) is not present.
-x index
  Changes the default file read for directories from “index.html” to index.
-z ciphers
  Sets the list of SSL ciphers (see SSL_CTX_set_cipher_list(3)).
-Z certificate_path privatekey_path
  Sets the path to the server certificate file and the private key file in pem format. It also causes bozohttpd to start SSL mode.

Note that in bozohttpd versions 20031005 and prior that supported the -C and -M options, they took a single space-separated argument that was parsed. since version 20040828, they take multiple options (2 in the case of -C and 4 in the case of -M.)

## INETD CONFIGURATION

As bozohttpd uses inetd(8) by default to process incoming TCP connections for HTTP requests (but see the -b option), bozohttpd has little internal networking knowledge. (Indeed, you can run it on the command line with little change of functionality.) A typical inetd.conf(5) entry would be:

    http stream tcp  nowait:600 _httpd /usr/libexec/httpd httpd /var/www
    http stream tcp6 nowait:600 _httpd /usr/libexec/httpd httpd /var/www

This would serve web pages from /var/www on both IPv4 and IPv6 ports. The :600 changes the requests per minute to 600, up from the inetd(8) default of 40.
Using the NetBSD inetd(8), you can provide multiple IP-address based HTTP servers by having multiple listening ports with different configurations.

## NOTES

This server supports the HTTP/0.9, HTTP/1.0, and HTTP/1.1 standards. Support for these protocols is very minimal and many optional features are not supported.
bozohttpd can be compiled without CGI support (NO_CGIBIN_SUPPORT), user transformations (NO_USER_SUPPORT), directory index support (NO_DIRINDEX_SUPPORT), daemon mode support (NO_DAEMON_MODE), dynamic MIME content (NO_DYNAMIC_CONTENT), Lua support (NO_LUA_SUPPORT), and SSL support (NO_SSL_SUPPORT) by defining the listed macros when building bozohttpd.

## HTTP BASIC AUTHORISATION

bozohttpd has support for HTTP Basic Authorisation. If a file named .htpasswd exists in the directory of the current request, bozohttpd will restrict access to documents in that directory using the RFC 2617 HTTP “Basic” authentication scheme.
Note: This does not recursively protect any sub-directories.
The .htpasswd file contains lines delimited with a colon containing usernames and passwords hashed with crypt(3), for example:

    heather:$1$pZWI4tH/$DzDPl63i6VvVRv2lJNV7k1
    jeremy:A.xewbx2DpQ8I

On NetBSD, the pwhash(1) utility may be used to generate hashed passwords.
While bozohttpd distributed with NetBSD has support for HTTP Basic Authorisation enabled by default, in the portable distribution it is excluded. Compile bozohttpd with “-DDO_HTPASSWD” on the compiler command line to enable this support. It may require linking with the crypt library, using “-lcrypt”.

## SSL SUPPORT

bozohttpd has support for TLSv1.1 and TLSv1.2 protocols that are included by default. It requires linking with the crypto and ssl library, using “-lcrypto -lssl”. To disable SSL SUPPORT compile bozohttpd with “-DNO_SSL_SUPPORT” on the compiler command line.

## COMPRESSION

bozohttpd supports a very basic form of compression. bozohttpd will serve the requested file postpended with “.gz” if it exists, it is readable, the client requested gzip compression, and the client did not make a ranged request.

# FILES

bozohttpd looks for a couple of special files in directories that allow certain features to be provided on a per-directory basis. In addition to the .htpasswd used by HTTP basic authorisation, if a .bzdirect file is found (contents are irrelevant) bozohttpd will allow direct access even with the -r option. If a .bzredirect symbolic link is found, bozohttpd will perform a smart redirect to the target of this symlink. The target is assumed to live on the same server. If target starts with slash then absolute redirection is performed, otherwise it's handled as relative. If a .bzabsredirect symbolic link is found, bozohttpd will redirect to the absolute url pointed to by this symlink. This is useful to redirect to different servers. Two forms of redirection are supported - symbolic link without schema will use http:// as default i.e. link to NetBSD.org will redirect to http://NetBSD.org/ Otherwise provided schema will be used i.e. symbolic link to ftp://NetBSD.org/ will redirect to provided the URL.

# EXAMPLES

To configure set of virtual hosts, one would use an inetd.conf(5) entry like:

    http stream tcp  nowait:600 _httpd /usr/libexec/httpd httpd -v /var/vroot /var/www

and inside /var/vroot create a directory (or a symlink to a directory) with the same name as the virtual host, for each virtual host. Lookups for these names are done in a case-insensitive manner, and may include the port number part of the request, allowing for distinct virtual hosts on the same name.
To use bozohttpd with PHP, one must use the -C option to specify a CGI handler for a particular file type. Typically this will be like:

    httpd -C .php /usr/pkg/bin/php-cgi /var/www

# SEE ALSO

inetd.conf(5), inetd(8)

# HISTORY

bozohttpd was first written in perl, based on another perl http server called “tinyhttpd”. It was then rewritten from scratch in perl, and then once again in C. From “bozohttpd” version 20060517, it has been integrated into NetBSD. The focus has always been simplicity and security, with minimal features and regular code audits. This manual documents bozohttpd version 20170201.

# AUTHORS

bozohttpd was written by Matthew R. Green <mrg@eterna.com.au>.
The large list of contributors includes:

- Marc Balmer <mbalmer@NetBSD.org> added Lua support for dynamic content creation
- Christoph Badura <bad@bsd.de> provided Range: header support
- Sean Boudreau <seanb@NetBSD.org> provided a security fix for virtual hosting
- Julian Coleman <jdc@coris.org.uk> provided an IPv6 bugfix
- Chuck Cranor <chuck@research.att.com> provided cgi-bin support fixes, and more
- Alistair G. Crooks <agc@NetBSD.org> cleaned up many internal interfaces, made bozohttpd linkable as a library and provided the Lua binding.
- DEGROOTE Arnaud <degroote@NetBSD.org> provided a fix for daemon mode
- Andrew Doran <ad@NetBSD.org> provided directory indexing support
- Per Ekman <pek@pdc.kth.se> provided a fix for a minor (non-security) buffer overflow condition
- Roland Dowdeswell <elric@NetBSD.org> added support for serving gzipped files and better SSL handling
- Jun-ichiro itojun Hagino, KAME <itojun@iijlab.net> provided initial IPv6 support
- Martin Husemann <martin@NetBSD.org> provided .bzabsredirect support, and fixed various redirection issues
- Arto Huusko <arto.huusko@pp2.inet.fi> provided fixes cgi-bin
- Roland Illig <roland.illig@gmx.de> provided some off-by-one fixes
- Zak Johnson <zakj@nox.cx> provided cgi-bin enhancements
- Nicolas Jombart <ecu@ipv42.net> provided fixes for HTTP basic authorisation support
- Antti Kantee <pooka@NetBSD.org> provided fixes for HTTP basic authorisation support
- Thomas Klausner <wiz@NetBSD.org> provided many fixes and enhancements for the man page
- Mateusz Kocielski <shm@NetBSD.org> fixed memory leaks, various issues with userdir support, information disclosure issues, added support for using CGI handlers with directory indexing, found several security issues and provided various other fixes.
- Arnaud Lacombe <alc@NetBSD.org> provided some clean up for memory leaks
- Johnny Lam <jlam@NetBSD.org> provided man page fixes
- Dennis Lindroos <denafcm@gmail.com> provided a cgi-bin fix
- Julio Merino <jmmv@NetBSD.org> Added the -P option (pidfile support) and provided some man page fixes.
- Luke Mewburn <lukem@NetBSD.org> provided many various fixes, including cgi-bin fixes and enhancements, HTTP basic authorisation support and much code clean up
- Rajeev V. Pillai <rajeev_v_pillai@yahoo.com> provided several fixes for virtual hosting
- Jeremy C. Reed <reed@NetBSD.org> provided several clean up fixes, and man page updates
- Scott Reynolds <scottr@NetBSD.org> provided various fixes
- Tyler Retzlaff <rtr@eterna.com.au> provided SSL support, cgi-bin fixes and much other random other stuff
- rudolf <netbsd@eq.cz> provided minor compile fixes and a CGI content map fix
- Steve Rumble <rumble@ephemeral.org> provided the -V option.
- Thor Lancelot Simon <tls@NetBSD.org> enhanced cgi-bin support.
- Joerg Sonnenberger <joerg@NetBSD.org> implemented If-Modified-Since support
- ISIHARA Takanori <ishit@oak.dti.ne.jp> provided a man page fix
- Holger Weiss <holger@CIS.FU-Berlin.DE> provided http authorisation fixes
- <xs@kittenz.org> provided chroot and change-to-user support, and other various fixes
- Coyote Point provided various CGI fixes.

There are probably others I have forgotten (let me know if you care)
Please send all updates to bozohttpd to <mrg@eterna.com.au> for inclusion in future releases.

# BUGS

bozohttpd does not handle HTTP/1.1 chunked input from the client yet.

February 1, 2017 | NetBSD 8.0